(*** extended tea library ***)
(* coded by ScareByte [uCF] *)
(****************************)
unit stea;

interface

// TEA DEFINITION AND PROCEDURE //
(***************************************************************)
type ttea = record
            key  : array[0..3] of LongWord;
            data : array[0..1] of LongWord;
            end;

// Encode: n =  32
// Decode: n = -32

procedure tea(var t: ttea; n: integer);


implementation

procedure tea(var t: ttea; n: integer);
const delta = $9E3779B9;
var   sum, y, z: LongWord;
begin
 y := t.data[0];
 z := t.data[1];
 if n > 0
    then begin // encode
         sum   := 0;
         while n > 0 do begin
               inc(sum, delta);
               inc(y, (z shl 4 + t.key[0]) xor (z + sum) xor (z shr 5 + t.key[1]));
               inc(z, (y shl 4 + t.key[2]) xor (y + sum) xor (y shr 5 + t.key[3]));
               dec(n);
               end;
         end
    else begin // decode
         sum   := delta shl 5;
         while n < 0 do begin
               dec(z, (y shl 4 + t.key[2]) xor (y + sum) xor (y shr 5 + t.key[3]));
               dec(y, (z shl 4 + t.key[0]) xor (z + sum) xor (z shr 5 + t.key[1]));
               dec(sum, delta);
               inc(n);
               end;
         end;
 t.data[0] := y;
 t.data[1] := z;
end;


end.
